<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [Graph/collapse-helper][1]
    -   [\_isLeafDirected][2]
    -   [\_isLeafNotDirected][3]
    -   [\_isLeaf][4]
    -   [computeNodeDegree][5]
    -   [getTargetLeafConnections][6]
    -   [isNodeVisible][7]
    -   [toggleLinksConnections][8]
    -   [toggleLinksMatrixConnections][9]
-   [Graph/builder][10]
    -   [\_getNodeOpacity][11]
    -   [buildLinkProps][12]
    -   [buildNodeProps][13]
-   [graph.config][14]
-   [Graph/helper][15]
    -   [Link][16]
    -   [Node][17]
    -   [\_createForceSimulation][18]
    -   [\_initializeLinks][19]
    -   [\_initializeNodes][20]
    -   [\_mergeDataLinkWithD3Link][21]
    -   [\_tagOrphanNodes][22]
    -   [\_validateGraphData][23]
    -   [\_pickId][24]
    -   [\_pickSourceAndTarget][25]
    -   [checkForGraphElementsChanges][26]
    -   [checkForGraphConfigChanges][27]
    -   [getCenterAndZoomTransformation][28]
    -   [initializeGraphState][29]
    -   [updateNodeHighlightedValue][30]
-   [Link/const][31]
    -   [LINE_TYPES][32]
-   [Link/helper][33]
    -   [straightLineRadius][34]
    -   [smoothCurveRadius][35]
    -   [fullCurveRadius][36]
    -   [getRadiusStrategy][37]
    -   [buildLinkPathDefinition][38]
-   [Marker/helper][39]
    -   [\_markerKeyBuilder][40]
    -   [\_getMarkerSize][41]
    -   [\_computeMarkerId][42]
    -   [\_memoizedComputeMarkerId][43]
    -   [getMarkerId][44]
-   [Node/helper][45]
    -   [\_convertTypeToD3Symbol][46]
    -   [buildSvgSymbol][47]
-   [Graph][48]
    -   [\_generateFocusAnimationProps][49]
    -   [\_graphLinkForceConfig][50]
    -   [\_graphNodeDragConfig][51]
    -   [\_graphBindD3ToReactComponent][52]
    -   [\_onDragEnd][53]
    -   [\_onDragMove][54]
    -   [\_onDragStart][55]
    -   [\_setNodeHighlightedValue][56]
    -   [\_tick][57]
    -   [\_zoomConfig][58]
    -   [\_zoomed][59]
    -   [onClickGraph][60]
    -   [onClickNode][61]
    -   [onMouseOverNode][62]
    -   [onMouseOutNode][63]
    -   [onMouseOverLink][64]
    -   [onMouseOutLink][65]
    -   [pauseSimulation][66]
    -   [resetNodesPositions][67]
    -   [restartSimulation][68]
    -   [UNSAFE_componentWillReceiveProps][69]
-   [Graph/renderer][70]
    -   [\_renderLinks][71]
    -   [\_renderNodes][72]
    -   [\_renderDefs][73]
    -   [\_memoizedRenderDefs][74]
    -   [renderGraph][75]
-   [Marker][76]
-   [Node][77]
    -   [handleOnClickNode][78]
    -   [handleOnRightClickNode][79]
    -   [handleOnMouseOverNode][80]
    -   [handleOnMouseOutNode][81]
-   [Link][82]
    -   [handleOnClickLink][83]
    -   [handleOnRightClickLink][84]
    -   [handleOnMouseOverLink][85]
    -   [handleOnMouseOutLink][86]
-   [utils][87]
    -   [\_isPropertyNestedObject][88]
    -   [isDeepEqual][89]
    -   [isEmptyObject][90]
    -   [deepClone][91]
    -   [merge][92]
    -   [pick][93]
    -   [antiPick][94]
    -   [throwErr][95]

## Graph/collapse-helper

Offers a series of methods that allow graph to perform the necessary operations to
create the collapsible behavior.

Developer notes - collapsing nodes and maintaining state on links matrix.

User interaction flow (for a collapsible graph)
1\. User clicks node
2\. All leaf connections of that node are not rendered anymore
3\. User clicks on same node
4\. All leaf connections of that node are rendered

Internal react-d3-graph flow
1\. User clicks node
2\. Compute leaf connections for clicked node (rootNode, root as in 'root' of the event)
3\. Update connections matrix (based on 2.)
4\. Update d3Links array with toggled connections (based on 2.)

### \_isLeafDirected

For directed graphs.
Check based on node degrees whether it is a leaf node or not.

**Parameters**

-   `inDegree` **[number][96]** the in degree for a given node.
-   `outDegree` **[number][96]** the out degree for a given node.

Returns **[boolean][97]** based on the degrees tells whether node is leaf or not.

### \_isLeafNotDirected

For not directed graphs.
Check based on node degrees whether it is a leaf node or not.

**Parameters**

-   `inDegree` **[number][96]** the in degree for a given node.
-   `outDegree` **[number][96]** the out degree for a given node.

Returns **[boolean][97]** based on the degrees tells whether node is leaf or not.

### \_isLeaf

Given in and out degree tells whether degrees indicate a leaf or non leaf scenario.

**Parameters**

-   `nodeId` **[string][98]** The id of the node to get the cardinality of.
-   `linksMatrix` **[Object][99]&lt;[string][98], [number][96]>** An object containing a matrix of connections of the nodes.
-   `directed` **[boolean][97]** whether graph in context is directed or not.

Returns **[boolean][97]** flag that indicates whether node is leaf or not.

### computeNodeDegree

Calculates degree (in and out) of some provided node.

**Parameters**

-   `nodeId` **([string][98] \| [number][96])** the id of the node whom degree we want to compute.
-   `linksMatrix` **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph, for each nodeId,
    there is an object that maps adjacent nodes ids (string) and their values (number). (optional, default `{}`)

Returns **[Object][99]&lt;[string][98], [number][96]>** returns object containing in and out degree of the node:- inDegree: number

-   outDegree: number

### getTargetLeafConnections

Given a node id we want to calculate the list of leaf connections

**Parameters**

-   `rootNodeId` **[string][98]** node who's leafs we want to calculate.
-   `linksMatrix` **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph, for each nodeId,
    there is an object that maps adjacent nodes ids (string) and their values (number). (optional, default `{}`)
-   `config` **[Object][99]** same as [config in renderGraph][70].
    -   `config.directed` **[boolean][97]** tells whether linksMatrix represents a directed graph or not.

Returns **[Array][100]&lt;[Object][99]&lt;[string][98], [string][98]>>** a list of leaf connections.
What is a leaf connection? A leaf connection is a link between some node A and other node B
where A has id equal to rootNodeId and B has inDegree 1 and outDegree 0 (or outDegree 1 but the connection is with A).

### isNodeVisible

Given a node and the connections matrix, check if node should be displayed
NOTE: this function is meant to be used under the `collapsible` toggle, meaning
that the `isNodeVisible` actually is checking visibility on collapsible graphs.
If you think that this code is confusing and could potentially collide (🤞) with #\_isLeaf
always remember that _A leaf can, through time, be both a visible or an invisible node!_.

**Parameters**

-   `nodeId` **[string][98]** The id of the node to get the cardinality of
-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** an object containing all nodes mapped by their id.
-   `linksMatrix` **[Object][99]&lt;[string][98], [number][96]>** An object containing a matrix of connections of the nodes.

Returns **[boolean][97]** flag that indicates whether node should or not be displayed.

### toggleLinksConnections

Updates d3Links by toggling given connections

**Parameters**

-   `d3Links` **[Array][100]&lt;[Object][99]>** An array containing all the d3 links.
-   `connectionMatrix` **[Array][100]&lt;[Object][99]&lt;[string][98], [string][98]>>** connections to toggle.

Returns **[Array][100]&lt;[Object][99]>** updated d3Links.

### toggleLinksMatrixConnections

Update matrix given array of connections to toggle.

**Parameters**

-   `linksMatrix` **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph, for each nodeId,
    there is an object that maps adjacent nodes ids (string) and their values (number).
-   `connections` **[Array][100]&lt;[Object][99]&lt;[string][98], [string][98]>>** connections to toggle on matrix.
-   `config` **[Object][99]** same as [config in renderGraph][70].
    -   `config.directed` **[boolean][97]** tells whether linksMatrix represents a directed graph or not.

Returns **[Object][99]&lt;[string][98], [Object][99]>** updated linksMatrix

## Graph/builder

Offers a series of methods that isolate the way graph elements are built (nodes and links mainly).

### \_getNodeOpacity

Get the correct node opacity in order to properly make decisions based on context such as currently highlighted node.

**Parameters**

-   `node` **[Object][99]** the node object for whom we will generate properties.
-   `highlightedNode` **[string][98]** same as [highlightedNode in renderGraph][70].
-   `highlightedLink` **[Object][99]** same as [highlightedLink in renderGraph][70].
-   `config` **[Object][99]** same as [config in renderGraph][70].

Returns **[number][96]** the opacity value for the given node.

### buildLinkProps

Build some Link properties based on given parameters.

**Parameters**

-   `link` **[Object][99]** the link object for which we will generate properties.
-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** same as [nodes in renderGraph][70].
-   `links` **[Object][99]&lt;[string][98], [Object][99]>** same as [links in renderGraph][70].
-   `config` **[Object][99]** same as [config in renderGraph][70].
-   `linkCallbacks` **[Array][100]&lt;[Function][101]>** same as [linkCallbacks in renderGraph][70].
-   `highlightedNode` **[string][98]** same as [highlightedNode in renderGraph][70].
-   `highlightedLink` **[Object][99]** same as [highlightedLink in renderGraph][70].
-   `transform` **[number][96]** value that indicates the amount of zoom transformation.

Returns **[Object][99]** returns an object that aggregates all props for creating respective Link component instance.

### buildNodeProps

Build some Node properties based on given parameters.

**Parameters**

-   `node` **[Object][99]** the node object for whom we will generate properties.
-   `config` **[Object][99]** same as [config in renderGraph][70].
-   `nodeCallbacks` **[Array][100]&lt;[Function][101]>** same as [nodeCallbacks in renderGraph][70]. (optional, default `{}`)
-   `highlightedNode` **[string][98]** same as [highlightedNode in renderGraph][70].
-   `highlightedLink` **[Object][99]** same as [highlightedLink in renderGraph][70].
-   `transform` **[number][96]** value that indicates the amount of zoom transformation.

Returns **[Object][99]** returns object that contain Link props ready to be feeded to the Link component.

## graph.config

<div style="text-align: right;"><i>This is certainly the only extra piece of documentation that you will ever need</i></div>
<br/><br/>
Here you can consult a detailed description of each graph configurable property as well as the default values
of those properties.

**Note about performance**<br/>
Some of the properties have a major performance impact when toggled while rendering graphs of medium or large dimensions (hundreds or thousand of elements).
These properties are marked with 🚅🚅🚅.<br/>
⭐ **tip** _to achieve smoother interactions you may want to provide a toggle to set **staticGraph** or (better) **staticGraphWithDragAndDrop** to **true** _<br/>
<br/>
**Note about granularity**<br/>
Some of the properties listed in the [Node section][102] are marked with 🔍🔍🔍. This means that this properties
have a higher level of granularity. These properties can be defined in the graph payload at a node level. (sample payload below)

```javascript
const graph = {
    nodes: [
        {
            id: "id",
            color: "red",         // only this node will be red
            size: 300,            // only this node will have size 300
            symbolType: "diamond" // only this node will have "diamond" shape
        }
    ],
    links: [...]
};
```

<br/>

-   <a href="#config-global">Graph global configurations</a>
-   <a href="#config-d3">d3 level configurations</a>
-   <a href="#config-node">Node level configurations</a>
-   <a href="#config-link">Link level configurations</a>

<br/>

<h2 id="config-global"><a href="#config-global">#</a>  Graph global configurations</h2>

**Parameters**

-   `automaticRearrangeAfterDropNode` **[boolean][97]** 🚅🚅🚅 when true performing a node drag and drop should automatically
    rearrange all nodes positions based on new position of dragged node (note: **staticGraph** should be false). (optional, default `false`)
-   `collapsible` **[boolean][97]** 🚅🚅🚅 Allow leaf neighbors nodes to be collapsed (folded), this will allow users to clear the way out and focus on the parts of the graph that really matter.
    To see an example of this behavior you can access this sandbox link that has a specific set up to experiment this feature. **NOTE**: At this moment
    nodes without connections (orphan nodes) are not rendered when this property is activated (see [react-d3-graph/issues/#129][103]).
    <br/>
    <img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-collapsible.gif?raw=true" width="820" height="480"/> (optional, default `false`)
-   `directed` **[boolean][97]** This property makes react-d3-graph handle your graph as a directed graph. It will
    out of the box provide the look and feel of a directed graph and add directional semantic to links. You can see a sample in the image below.
    <br/>
    <img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-directed.gif?raw=true" width="820" height="480"/> (optional, default `false`)
-   `focusZoom` **[number][96]** zoom that will be applied when the graph view is focused in a node. Its value must be between
    _minZoom_ and _maxZoom_. If the specified _focusZoom_ is out of this range, _minZoom_ or _maxZoom_ will be applied instead.
    **NOTE:** This animation is not trigger by default. In order to trigger it you need to pass down to `react-d3-graph` the
    node that you want to focus via prop `focusedNodeId` along side with nodes and links:`javascript const data = { nodes: this.state.data.nodes, links: this.state.data.links, focusedNodeId: "nodeIdToTriggerZoomAnimation" };`<img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-zoom-animation.gif?raw=true" width="820" height="480"/> (optional, default `1`)
-   `focusAnimationDuration` **[number][96]** duration (in seconds) for the animation that takes place when focusing the graph on a node. (optional, default `0.75`)
-   `height` **[number][96]** the height of the (svg) area where the graph will be rendered. (optional, default `400`)
-   `nodeHighlightBehavior` **[boolean][97]** 🚅🚅🚅 when user mouse hovers a node that node and adjacent common
    connections will be highlighted (depending on the _highlightDegree_ value). All the remaining nodes and links assume opacity value equal to **highlightOpacity**. (optional, default `false`)
-   `linkHighlightBehavior` **[boolean][97]** 🚅🚅🚅 when the user mouse hovers some link that link and the correspondent nodes will be highlighted, this is a similar behavior
    to _nodeHighlightBehavior_ but for links <small>(just for historical reference this property was introduced in **v1.0.0**)</small>. (optional, default `false`)
-   `highlightDegree` **[number][96]** **Possible values: 0, 1 or 2**. This value represents the range of the
    highlight behavior when some node is highlighted. If the value is set to **0** only the selected node will be
    highlighted. If the value is set to **1** the selected node and his 1st degree connections will be highlighted. If
    the value is set to **2** the selected node will be highlighted as well as the 1st and 2nd common degree connections. (optional, default `1`)
-   `highlightOpacity` **[number][96]** this value is used to highlight nodes in the network. The lower
    the value the more the less highlighted nodes will be visible (related to _nodeHighlightBehavior_). (optional, default `1`)
-   `maxZoom` **[number][96]** max zoom that can be performed against the graph. (optional, default `8`)
-   `minZoom` **[number][96]** min zoom that can be performed against the graph. (optional, default `0.1`)
-   `panAndZoom` **[boolean][97]** 🚅🚅🚅 pan and zoom effect when performing zoom in the graph,
    a similar functionality may be consulted [here][104]. (optional, default `false`)
-   `staticGraph` **[boolean][97]** when setting this value to true the graph will be completely static, thus
    all forces and drag events upon nodes will produce not effect. Note that, if this value is true the nodes will be
    rendered with the initial provided **x and y coordinates** (links positions will be automatically set
    from the given nodes positions by rd3g), no coordinates will be calculated by rd3g or subjacent d3 modules. (optional, default `false`)
-   `staticGraphWithDragAndDrop` **[boolean][97]?** exactly the same as above `staticGraph`, but it will allow users to drag&drop nodes.
    **Note**: If `staticGraph` is set to `true`, then `staticGraphWithDragAndDrop` will not produce the desired behaviour, make sure
    to set only one of them to `true`.
-   `width` **[number][96]** the width of the (svg) area where the graph will be rendered.
    <br/> (optional, default `800`)
-   `d3` **[Object][99]** d3 object is explained in next section. ⬇️<h2 id="config-d3"><a href="#config-d3">#</a> d3 level configurations</h2>
    -   `d3.alphaTarget` **[number][96]** [see d3-force simulation.alphaTarget][105] (optional, default `0.05`)
    -   `d3.gravity` **[number][96]** this will define how close nodes are to each other ([see d3 reference for forces][106]).- If value is positive, nodes will attract each other.
        -   If value is negative, nodes will repel each other. Most of the times this is what we want, so nodes don"t overlap. (optional, default `-100`)
    -   `d3.linkLength` **[number][96]** the length of each link from the center of the nodes it joins. (optional, default `100`)
    -   `d3.linkStrength` **[number][96]** [see d3-force link.strength][107]
        <br/> (optional, default `1`)
-   `node` **[Object][99]** node object is explained in next section. ⬇️<h2 id="config-node"><a href="#config-node">#</a> Node level configurations</h2>
    -   `node.color` **[string][98]** 🔍🔍🔍 this is the color that will be applied to the node if no **color property**
        is found inside the node itself (yes **you can pass a property "color" inside the node and that color will override the
        this default one**). (optional, default `"#d3d3d3"`)
    -   `node.fontColor` **[string][98]** 🔍🔍🔍 fill color for node"s <text> svg label. (optional, default `"black"`)
    -   `node.fontSize` **[number][96]** [font-size][108]
        property for all nodes" labels. (optional, default `8`)
    -   `node.fontWeight` **[string][98]** [font-weight][109]
        property for all nodes" labels. (optional, default `"normal"`)
    -   `node.highlightColor` **[string][98]** color for all highlighted nodes (use string "SAME" if you
        want the node to keep its color in highlighted state). (optional, default `"SAME"`)
    -   `node.highlightFontSize` **[number][96]** fontSize in highlighted state. (optional, default `8`)
    -   `node.highlightFontWeight` **[string][98]** fontWeight in highlighted state. (optional, default `"normal"`)
    -   `node.highlightStrokeColor` **[string][98]** strokeColor in highlighted state. (optional, default `"SAME"`)
    -   `node.highlightStrokeWidth` **[number][96]** strokeWidth in highlighted state. (optional, default `"SAME"`)
    -   `node.labelProperty` **([string][98] \| [Function][101])** this is the node property that will be used in runtime to
        fetch the label content. You just need to add some property (e.g. firstName) to the node payload and then set
        node.labelProperty to be **"firstName"**. **This can also be a function!**, if you pass a function here it will be called
        to obtain the `label` value on the fly, as a client you will receive all the node information that you passed down into react-d3-graph,
        so the signature of the function would be:`javascript function myCustomLabelBuilder(node) { // do stuff to get the final result... return "label string"; }`Then you just need to make sure that you pass this function in the config in `config.node.labelProperty`.
        <br/> (optional, default `"id"`)
    -   `node.mouseCursor` **[string][98]** [cursor][110]
        property for when some node is mouse hovered. (optional, default `"pointer"`)
    -   `node.opacity` **[number][96]** 🔍🔍🔍 - by default all nodes will have this opacity value. (optional, default `1`)
    -   `node.renderLabel` **[boolean][97]** when set to false no labels will appear along side nodes in the
        graph. (optional, default `true`)
    -   `node.size` **[number][96]** 🔍🔍🔍 defines the size of all nodes. (optional, default `200`)
    -   `node.strokeColor` **[string][98]** 🔍🔍🔍 this is the stroke color that will be applied to the node if no **strokeColor property** is found inside the node itself (yes **you can pass a property "strokeColor" inside the node and that stroke color will override this default one** ). (optional, default `"none"`)
    -   `node.strokeWidth` **[number][96]** 🔍🔍🔍 - the width of the all node strokes. (optional, default `1.5`)
    -   `node.svg` **[string][98]** 🔍🔍🔍 render custom svg for nodes in alternative to **node.symbolType**. This svg can
        be provided as a string to either a remote svg resource or for a local one.
        <br/>
        <img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-custom-svg.gif?raw=true" width="820" height="480"/> (optional, default `""`)
    -   `node.symbolType` **[string][98]** 🔍🔍🔍 the <span id="node-symbol-type">shape</span> of the node.
        Use the following values under a property **type** inside each node (nodes may have different types, same as colors):- "circle"
        -   "cross"
        -   "diamond"
        -   "square"
        -   "star"
        -   "triangle"
        -   "wye"**[note]** react-d3-graph will map this values to [d3 symbols][111] (optional, default `"circle"`)
    -   `node.viewGenerator` **[Function][101]** 🔍🔍🔍 function that receives a node and returns a JSX view.
        <br/> (optional, default `null`)
-   `link` **[Object][99]** link object is explained in the next section. ⬇️<h2 id="config-link"><a href="#config-link">#</a> Link level configurations</h2>
    -   `link.color` **[string][98]** 🔍🔍🔍 the color for links
        (from version 1.3.0 this property can be configured at link level). (optional, default `"#d3d3d3"`)
    -   `link.fontColor` **[string][98]** 🔍🔍🔍 fill color for link's <text> svg label. (optional, default `"black"`)
    -   `link.fontSize` **[number][96]** [font-size][108]
        property for all links' labels. (optional, default `8`)
    -   `link.fontWeight` **[string][98]** [font-weight][109]
        property for all links' labels. (optional, default `"normal"`)
    -   `link.highlightColor` **[string][98]** links' color in highlight state.
        <img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-bend.gif?raw=true" width="820" height="480"/> (optional, default `"#d3d3d3"`)
    -   `link.highlightFontSize` **[number][96]** fontSize in highlighted state. (optional, default `8`)
    -   `link.highlightFontWeight` **[string][98]** fontWeight in highlighted state. (optional, default `"normal"`)
    -   `link.labelProperty` **([string][98] \| [Function][101])** the property that will be rendered as label within some link. Note that
        this property needs to be passed along the link payload (along side with source and target). This property can also be a function
        that receives the link itself as argument and returns a custom string, similarly to what happens with `node.labelProperty`. (optional, default `"label"`)
    -   `link.mouseCursor` **[string][98]** [cursor][110]
        property for when link is mouse hovered. (optional, default `"pointer"`)
    -   `link.opacity` **[number][96]** 🔍🔍🔍 - the default opacity value for links. (optional, default `1`)
    -   `link.renderLabel` **[boolean][97]** when set to true labels will appear along side links in the
        graph. **Note**: this will only happen of course if proper label is passed within the link, check also `link.labelProperty`.
        <br/>
        <img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-link-render-label.png?raw=true" width="820" height="480"/> (optional, default `false`)
    -   `link.semanticStrokeWidth` **[boolean][97]** when set to true all links will have
        _"semantic width"_, this means that the width of the connections will be proportional to the value of each link.
        This is how link strokeWidth will be calculated:`javascript strokeWidth += (linkValue * strokeWidth) / 10;` (optional, default `false`)
    -   `link.strokeWidth` **[number][96]** 🔍🔍🔍 - strokeWidth for all links. By default the actual value is obtain by the
        following expression:`javascript link.strokeWidth * (1 / transform); // transform is a zoom delta Δ value` (optional, default `1.5`)
    -   `link.type` **[string][98]** the type of line to draw, available types at this point are:- "STRAIGHT" <small>(default)</small> - a straight line.
        -   "CURVE_SMOOTH" - a slight curve between two nodes
        -   "CURVE_FULL" - a semicircumference trajectory unites source and target nodes.
            <br/>
            <img src="https://github.com/danielcaldas/react-d3-graph/blob/master/docs/rd3g-bend.gif?raw=true" width="820" height="480"/> (optional, default `"STRAIGHT"`)

**Examples**

```javascript
// A simple config that uses some properties
const myConfig = {
    nodeHighlightBehavior: true,
    node: {
        color: "lightgreen",
        size: 120,
        highlightStrokeColor: "blue",
    },
    link: {
        highlightColor: "lightblue",
    },
};

// Sorry for the long config description, here"s a potato 🥔.
```

## Graph/helper

Offers a series of methods that isolate logic of Graph component and also from Graph rendering methods.

### Link

Type: [Object][99]

**Properties**

-   `source` **[string][98]** the node id of the source in the link.
-   `target` **[string][98]** the node id of the target in the link.

### Node

Type: [Object][99]

**Properties**

-   `id` **[string][98]** the id of the node.
-   `color` **[string][98]?** color of the node (optional).
-   `fontColor` **[string][98]?** node text label font color (optional).
-   `size` **[string][98]?** size of the node (optional).
-   `symbolType` **[string][98]?** symbol type of the node (optional).
-   `svg` **[string][98]?** custom svg for node (optional).

### \_createForceSimulation

Create d3 forceSimulation to be applied on the graph.<br/>
[d3-force#forceSimulation][112]<br/>
[d3-force#simulation_force][113]<br/>
Wtf is a force? [ here][106]

**Parameters**

-   `width` **[number][96]** the width of the container area of the graph.
-   `height` **[number][96]** the height of the container area of the graph.
-   `gravity` **[number][96]** the force strength applied to the graph.

Returns **[Object][99]** returns the simulation instance to be consumed.

### \_initializeLinks

Receives a matrix of the graph with the links source and target as concrete node instances and it transforms it
in a lightweight matrix containing only links with source and target being strings representative of some node id
and the respective link value (if non existent will default to 1).

**Parameters**

-   `graphLinks` **[Array][100]&lt;[Link][114]>** an array of all graph links.
-   `config` **[Object][99]** the graph config.

Returns **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph, for each nodeId,
there is an object that maps adjacent nodes ids (string) and their values (number).

### \_initializeNodes

Method that initialize graph nodes provided by rd3g consumer and adds additional default mandatory properties
that are optional for the user. Also it generates an index mapping, this maps nodes ids the their index in the array
of nodes. This is needed because d3 callbacks such as node click and link click return the index of the node.

**Parameters**

-   `graphNodes` **[Array][100]&lt;[Node][115]>** the array of nodes provided by the rd3g consumer.

Returns **[Object][99]&lt;[string][98], [Object][99]>** returns the nodes ready to be used within rd3g with additional properties such as x, y
and highlighted values.

### \_mergeDataLinkWithD3Link

Maps an input link (with format `{ source: 'sourceId', target: 'targetId' }`) to a d3Link
(with format `{ source: { id: 'sourceId' }, target: { id: 'targetId' } }`). If d3Link with
given index exists already that same d3Link is returned.

**Parameters**

-   `link` **[Object][99]** input link.
-   `index` **[number][96]** index of the input link.
-   `d3Links` **[Array][100]&lt;[Object][99]>** all d3Links. (optional, default `[]`)
-   `config` **[Object][99]** same as [config in renderGraph][70].
-   `state` **[Object][99]** Graph component current state (same format as returned object on this function). (optional, default `{}`)

Returns **[Object][99]** a d3Link.

### \_tagOrphanNodes

Tags orphan nodes with a `_orphan` flag.

**Parameters**

-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** nodes mapped by their id.
-   `linksMatrix` **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph, for each nodeId,
    there is an object that maps adjacent nodes ids (string) and their values (number).

Returns **[Object][99]&lt;[string][98], [Object][99]>** same input nodes structure with tagged orphans nodes where applicable.

### \_validateGraphData

Some integrity validations on links and nodes structure. If some validation fails the function will
throw an error.

**Parameters**

-   `data` **[Object][99]** Same as [data in initializeGraphState][116].

*   Throws **any** can throw the following error msg:
    INSUFFICIENT_DATA - msg if no nodes are provided
    INVALID_LINKS - if links point to nonexistent nodes

Returns **[undefined][117]**

### \_pickId

Picks the id.

**Parameters**

-   `o` **[Object][99]** object to pick from.

Returns **[Object][99]** new object with id property only.

### \_pickSourceAndTarget

Picks source and target.

**Parameters**

-   `o` **[Object][99]** object to pick from.

Returns **[Object][99]** new object with source and target only.

### checkForGraphElementsChanges

This function checks for graph elements (nodes and links) changes, in two different
levels of significance, updated elements (whether some property has changed in some
node or link) and new elements (whether some new elements or added/removed from the graph).

**Parameters**

-   `nextProps` **[Object][99]** nextProps that graph will receive.
-   `currentState` **[Object][99]** the current state of the graph.

Returns **[Object][99]&lt;[string][98], [boolean][97]>** returns object containing update check flags:- newGraphElements - flag that indicates whether new graph elements were added.

-   graphElementsUpdated - flag that indicates whether some graph elements have
    updated (some property that is not in NODE_PROPERTIES_DISCARD_TO_COMPARE was added to
    some node or link or was updated).

### checkForGraphConfigChanges

Logic to check for changes in graph config.

**Parameters**

-   `nextProps` **[Object][99]** nextProps that graph will receive.
-   `currentState` **[Object][99]** the current state of the graph.

Returns **[Object][99]&lt;[string][98], [boolean][97]>** returns object containing update check flags:- configUpdated - global flag that indicates if any property was updated.

-   d3ConfigUpdated - specific flag that indicates changes in d3 configurations.

### getCenterAndZoomTransformation

Returns the transformation to apply in order to center the graph on the
selected node.

**Parameters**

-   `d3Node` **[Object][99]** node to focus the graph view on.
-   `config` **[Object][99]** same as [config in renderGraph][70].

Returns **[string][98]** transform rule to apply.

### initializeGraphState

Encapsulates common procedures to initialize graph.

**Parameters**

-   `props` **[Object][99]** Graph component props, object that holds data, id and config.
    -   `props.data` **[Object][99]** Data object holds links (array of **Link**) and nodes (array of **Node**).
    -   `props.id` **[string][98]** the graph id.
    -   `props.config` **[Object][99]** same as [config in renderGraph][70].
-   `state` **[Object][99]** Graph component current state (same format as returned object on this function).

Returns **[Object][99]** a fully (re)initialized graph state object.

### updateNodeHighlightedValue

This function updates the highlighted value for a given node and also updates highlight props.

**Parameters**

-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** an object containing all nodes mapped by their id.
-   `links` **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph.
-   `config` **[Object][99]** an object containing rd3g consumer defined configurations [config][118] for the graph.
-   `id` **[string][98]** identifier of node to update.
-   `value` **[string][98]** new highlight value for given node. (optional, default `false`)

Returns **[Object][99]** returns an object containing the updated nodes
and the id of the highlighted node.

## Link/const

A set of constants that facilitate readability regarding links.

### LINE_TYPES

Type: [Object][99]

**Properties**

-   `STRAIGHT` **[string][98]** a straight line.
-   `CURVE_SMOOTH` **[string][98]** a slight curve between two nodes
-   `CURVE_FULL` **[string][98]** a semicircumference trajectory unites source and target nodes.

## Link/helper

A set of helper methods to manipulate/create links.

### straightLineRadius

Computes radius value for a straight line.

Returns **[number][96]** radius for straight line.

### smoothCurveRadius

Computes radius for a smooth curve effect.

**Parameters**

-   `x1` **[number][96]** x value for point 1
-   `y1` **[number][96]** y value for point 1
-   `x2` **[number][96]** y value for point 2
-   `y2` **[number][96]** y value for point 2

Returns **[number][96]** value of radius.

### fullCurveRadius

Computes radius value for a full curve (semi circumference).

Returns **[number][96]** radius for full curve.

### getRadiusStrategy

Get a strategy to compute line radius.<br/>
_CURVE_SMOOTH_ type inspired by [mbostock - Mobile Patent Suits][119].

**Parameters**

-   `type` **[string][98]** type of curve to get radius strategy from. (optional, default `LINE_TYPES.STRAIGHT`)

Returns **[Function][101]** a function that calculates a radius
to match curve type expectation. Fallback is the straight line.

### buildLinkPathDefinition

This method returns the path definition for a given link base on the line type
and the link source and target.
[d attribute mdn][120]

**Parameters**

-   `link` **[Object][99]** the link to build the path definition
    -   `link.source` **[Object][99]** link source (optional, default `{}`)
    -   `link.target` **[Object][99]** link target (optional, default `{}`)
-   `type` **[string][98]** the link line type (optional, default `LINE_TYPES.STRAIGHT`)

Returns **[string][98]** the path definition for the requested link

## Marker/helper

Offers a series of methods to compute proper markers within a given context.

### \_markerKeyBuilder

This function is a key template builder to access MARKERS structure.
WARN: function tightly coupled to the MARKERS object in marker.const.

**Parameters**

-   `size` **[string][98]** string that indicates size of marker.
-   `highlighted` **[string][98]** string that indicates highlight state of marker.

Returns **[string][98]** the key of the marker.

### \_getMarkerSize

This functions returns the proper marker size given the inputs that describe the scenario
where the marker is to be applied.

**Parameters**

-   `transform` **[number][96]** the delta zoom value to calculate resize transformations.
-   `mMax` **[number][96]** a derived value from the max zoom config.
-   `lMax` **[number][96]** a derived value from the min zoom config.

Returns **[string][98]** the size.

### \_computeMarkerId

This function holds logic to retrieve the appropriate marker id that reflects the input
parameters, markers can vary with highlight and transform value.

**Parameters**

-   `highlight` **[boolean][97]** tells us whether or not some element (link or node) is highlighted.
-   `transform` **[number][96]** the delta zoom value to calculate resize transformations.
-   `config` **[Object][99]** the graph config object.
    -   `config.maxZoom`

Returns **[string][98]** the id of the result marker.

### \_memoizedComputeMarkerId

This function memoize results for \_computeMarkerId
since many of the times user will be playing around with the same zoom
factor, we can take advantage of this and cache the results for a
given combination of highlight state, zoom transform value and maxZoom config.

Returns **[Function][101]** memoize wrapper to the \_computeMarkerId operation.

### getMarkerId

Memoized reference for \_memoizedComputeMarkerId exposed
as getter for sake of readability.
Gets proper marker id given the highlight state and the zoom
transform.

**Parameters**

-   `highlight` **[boolean][97]** tells us whether or not some element (link or node) is highlighted.
-   `transform` **[number][96]** the delta zoom value to calculate resize transformations.
-   `config` **[Object][99]** the graph config object.
    -   `config.maxZoom` **[Object][99]** max zoom that can be performed against the graph.

## Node/helper

Some methods that help no the process of rendering a node.

### \_convertTypeToD3Symbol

Converts a string that specifies a symbol into a concrete instance
of d3 symbol.<br/>
[https://github.com/d3/d3-shape/blob/master/README.md#symbol][121]

**Parameters**

-   `typeName` **[string][98]** the string that specifies the symbol type (should be one of [node.symbolType][122]).

Returns **[Object][99]** concrete instance of d3 symbol (defaults to circle).

### buildSvgSymbol

Build a d3 svg symbol based on passed symbol and symbol type.

**Parameters**

-   `size` **[number][96]** the size of the symbol. (optional, default `80`)
-   `symbolTypeDesc` **[string][98]** the string containing the type of symbol that we want to build
    (should be one of [node.symbolType][122]). (optional, default `'circle'`)

Returns **[Object][99]** concrete instance of d3 symbol.

## Graph

**Extends React.Component**

Graph component is the main component for react-d3-graph components, its interface allows its user
to build the graph once the user provides the data, configuration (optional) and callback interactions (also optional).
The code for the [live example][123]
can be consulted [here][124]

**Parameters**

-   `props`

**Examples**

```javascript
import { Graph } from "react-d3-graph";

// graph payload (with minimalist structure)
const data = {
    nodes: [{ id: "Harry" }, { id: "Sally" }, { id: "Alice" }],
    links: [{ source: "Harry", target: "Sally" }, { source: "Harry", target: "Alice" }],
};

// the graph configuration, you only need to pass down properties
// that you want to override, otherwise default ones will be used
const myConfig = {
    nodeHighlightBehavior: true,
    node: {
        color: "lightgreen",
        size: 120,
        highlightStrokeColor: "blue",
    },
    link: {
        highlightColor: "lightblue",
    },
};

// graph event callbacks
const onClickGraph = function() {
    window.alert("Clicked the graph background");
};

const onClickNode = function(nodeId) {
    window.alert("Clicked node ${nodeId}");
};

const onDoubleClickNode = function(nodeId) {
    window.alert("Double clicked node ${nodeId}");
};

const onRightClickNode = function(event, nodeId) {
    window.alert("Right clicked node ${nodeId}");
};

const onMouseOverNode = function(nodeId) {
    window.alert(`Mouse over node ${nodeId}`);
};

const onMouseOutNode = function(nodeId) {
    window.alert(`Mouse out node ${nodeId}`);
};

const onClickLink = function(source, target) {
    window.alert(`Clicked link between ${source} and ${target}`);
};

const onRightClickLink = function(event, source, target) {
    window.alert("Right clicked link between ${source} and ${target}");
};

const onMouseOverLink = function(source, target) {
    window.alert(`Mouse over in link between ${source} and ${target}`);
};

const onMouseOutLink = function(source, target) {
    window.alert(`Mouse out link between ${source} and ${target}`);
};

<Graph
    id="graph-id" // id is mandatory, if no id is defined rd3g will throw an error
    data={data}
    config={myConfig}
    onClickGraph={onClickGraph}
    onClickNode={onClickNode}
    onDoubleClickNode={onDoubleClickNode}
    onRightClickNode={onRightClickNode}
    onClickLink={onClickLink}
    onRightClickLink={onRightClickLink}
    onMouseOverNode={onMouseOverNode}
    onMouseOutNode={onMouseOutNode}
    onMouseOverLink={onMouseOverLink}
    onMouseOutLink={onMouseOutLink}
/>;
```

### \_generateFocusAnimationProps

Obtain a set of properties which will be used to perform the focus and zoom animation if
required. In case there's not a focus and zoom animation in progress, it should reset the
transition duration to zero and clear transformation styles.

Returns **[Object][99]** Focus and zoom animation properties.

### \_graphLinkForceConfig

This method runs [https://github.com/d3/d3-force][125]
against the current graph.

Returns **[undefined][117]**

### \_graphNodeDragConfig

This method runs [https://github.com/d3/d3-drag][126]
against the current graph.

Returns **[undefined][117]**

### \_graphBindD3ToReactComponent

Sets d3 tick function and configures other d3 stuff such as forces and drag events.
Whenever called binds Graph component state with d3.

Returns **[undefined][117]**

### \_onDragEnd

Handles d3 drag 'end' event.

Returns **[undefined][117]**

### \_onDragMove

Handles d3 'drag' event.
[more about d3 drag][127]

**Parameters**

-   `ev` **[Object][99]** if not undefined it will contain event data.
-   `index` **[number][96]** index of the node that is being dragged.
-   `nodeList` **[Array][100]&lt;[Object][99]>** array of d3 nodes. This list of nodes is provided by d3, each
    node contains all information that was previously fed by rd3g.

Returns **[undefined][117]**

### \_onDragStart

Handles d3 drag 'start' event.

Returns **[undefined][117]**

### \_setNodeHighlightedValue

Sets nodes and links highlighted value.

**Parameters**

-   `id` **[string][98]** the id of the node to highlight.
-   `value` **[boolean][97]** the highlight value to be set (true or false). (optional, default `false`)

Returns **[undefined][117]**

### \_tick

The tick function simply calls React set state in order to update component and render nodes
along time as d3 calculates new node positioning.

**Parameters**

-   `state` **[Object][99]** new state to pass on. (optional, default `{}`)
-   `cb` **[Function][101]?** optional callback to fed in to [https://reactjs.org/docs/react-component.html#setstate][128].

Returns **[undefined][117]**

### \_zoomConfig

Configures zoom upon graph with default or user provided values.<br/>
NOTE: in order for users to be able to double click on nodes, we
are disabling the native dblclick.zoom from d3 that performs a zoom
whenever a user double clicks on top of the graph.
[https://github.com/d3/d3-zoom#zoom][129]

Returns **[undefined][117]**

### \_zoomed

Handler for 'zoom' event within zoom config.

Returns **[Object][99]** returns the transformed elements within the svg graph area.

### onClickGraph

Calls the callback passed to the component.

**Parameters**

-   `e` **[Object][99]** The event of onClick handler.

Returns **[undefined][117]**

### onClickNode

Collapses the nodes, then checks if the click is doubled and calls the callback passed to the component.

**Parameters**

-   `clickedNodeId` **[string][98]** The id of the node where the click was performed.

Returns **[undefined][117]**

### onMouseOverNode

Handles mouse over node event.

**Parameters**

-   `id` **[string][98]** id of the node that participates in the event.

Returns **[undefined][117]**

### onMouseOutNode

Handles mouse out node event.

**Parameters**

-   `id` **[string][98]** id of the node that participates in the event.

Returns **[undefined][117]**

### onMouseOverLink

Handles mouse over link event.

**Parameters**

-   `source` **[string][98]** id of the source node that participates in the event.
-   `target` **[string][98]** id of the target node that participates in the event.

Returns **[undefined][117]**

### onMouseOutLink

Handles mouse out link event.

**Parameters**

-   `source` **[string][98]** id of the source node that participates in the event.
-   `target` **[string][98]** id of the target node that participates in the event.

Returns **[undefined][117]**

### pauseSimulation

Calls d3 simulation.stop().<br/>
[https://github.com/d3/d3-force#simulation_stop][130]

Returns **[undefined][117]**

### resetNodesPositions

This method resets all nodes fixed positions by deleting the properties fx (fixed x)
and fy (fixed y). Following this, a simulation is triggered in order to force nodes to go back
to their original positions (or at least new positions according to the d3 force parameters).

Returns **[undefined][117]**

### restartSimulation

Calls d3 simulation.restart().<br/>
[https://github.com/d3/d3-force#simulation_restart][131]

Returns **[undefined][117]**

### UNSAFE_componentWillReceiveProps

**Parameters**

-   `nextProps` **[Object][99]** props.

Returns **[undefined][117]**

**Meta**

-   **deprecated**: `componentWillReceiveProps` has a replacement method in react v16.3 onwards.
    that is getDerivedStateFromProps.
    But one needs to be aware that if an anti pattern of `componentWillReceiveProps` is
    in place for this implementation the migration might not be that easy.
    See [https://reactjs.org/blog/2018/06/07/you-probably-dont-need-derived-state.html][132].

## Graph/renderer

Offers a series of methods that isolate render logic for Graph component.

### \_renderLinks

Build Link components given a list of links.

**Parameters**

-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** same as [nodes in renderGraph][70].
-   `links` **[Array][100]&lt;[Object][99]>** array of links [Link][133].
-   `linksMatrix` **[Array][100]&lt;[Object][99]>** array of links [Link][133].
-   `config` **[Object][99]** same as [config in renderGraph][70].
-   `linkCallbacks` **[Array][100]&lt;[Function][101]>** same as [linkCallbacks in renderGraph][70].
-   `highlightedNode` **[string][98]** same as [highlightedNode in renderGraph][70].
-   `highlightedLink` **[Object][99]** same as [highlightedLink in renderGraph][70].
-   `transform` **[number][96]** value that indicates the amount of zoom transformation.

Returns **[Array][100]&lt;[Object][99]>** returns the generated array of Link components.

### \_renderNodes

Function that builds Node components.

**Parameters**

-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** an object containing all nodes mapped by their id.
-   `nodeCallbacks` **[Array][100]&lt;[Function][101]>** array of callbacks for used defined event handler for node interactions.
-   `config` **[Object][99]** an object containing rd3g consumer defined configurations [config][118] for the graph.
-   `highlightedNode` **[string][98]** this value contains a string that represents the some currently highlighted node.
-   `highlightedLink` **[Object][99]** this object contains a source and target property for a link that is highlighted at some point in time.
    -   `highlightedLink.source` **[string][98]** id of source node for highlighted link.
    -   `highlightedLink.target` **[string][98]** id of target node for highlighted link.
-   `transform` **[number][96]** value that indicates the amount of zoom transformation.
-   `linksMatrix` **[Object][99]&lt;[string][98], [Object][99]>** the matrix of connections of the graph

Returns **[Array][100]&lt;[Object][99]>** returns the generated array of node components

### \_renderDefs

Builds graph defs (for now markers, but we could also have gradients for instance).
NOTE: defs are static svg graphical objects, thus we only need to render them once, the result
is cached on the 1st call and from there we simply return the cached jsx.

Returns **[Function][101]** memoized build definitions function.

### \_memoizedRenderDefs

Memoized reference for \_renderDefs.

**Parameters**

-   `config` **[Object][99]** an object containing rd3g consumer defined configurations [config][118] for the graph.

Returns **[Object][99]** graph reusable objects [defs][134].

### renderGraph

Method that actually is exported an consumed by Graph component in order to build all Nodes and Link
components.

**Parameters**

-   `nodes` **[Object][99]&lt;[string][98], [Object][99]>** an object containing all nodes mapped by their id.
-   `nodeCallbacks` **[Array][100]&lt;[Function][101]>** array of callbacks for used defined event handler for node interactions.
-   `links` **[Array][100]&lt;[Object][99]>** array of links [Link][133].
-   `linksMatrix` **[Object][99]&lt;[string][98], [Object][99]>** an object containing a matrix of connections of the graph, for each nodeId,
    there is an Object that maps adjacent nodes ids (string) and their values (number).```javascript
    // links example
    {
    "Androsynth": {
    "Chenjesu": 1,
    "Ilwrath": 1,
    "Mycon": 1,
    "Spathi": 1,
    "Umgah": 1,
    "VUX": 1,
    "Guardian": 1
    },
    "Chenjesu": {
    "Androsynth": 1,
    "Mycon": 1,
    "Spathi": 1,
    "Umgah": 1,
    "VUX": 1,
    "Broodhmome": 1
    },
    ...
    }

    ```

    ```

-   `linkCallbacks` **[Array][100]&lt;[Function][101]>** array of callbacks for used defined event handler for link interactions.
-   `config` **[Object][99]** an object containing rd3g consumer defined configurations [config][118] for the graph.
-   `highlightedNode` **[string][98]** this value contains a string that represents the some currently highlighted node.
-   `highlightedLink` **[Object][99]** this object contains a source and target property for a link that is highlighted at some point in time.
    -   `highlightedLink.source` **[string][98]** id of source node for highlighted link.
    -   `highlightedLink.target` **[string][98]** id of target node for highlighted link.
-   `transform` **[number][96]** value that indicates the amount of zoom transformation.

Returns **[Object][99]** returns an object containing the generated nodes and links that form the graph.

## Marker

**Extends React.Component**

Market component provides configurable interface to marker definition.

**Examples**

```javascript
<Marker id="marker-id" fill="black" />
```

## Node

**Extends React.Component**

Node component is responsible for encapsulating node render.

**Examples**

```javascript
const onClickNode = function(nodeId) {
     window.alert('Clicked node', nodeId);
};

const onRightClickNode = function(nodeId) {
     window.alert('Right clicked node', nodeId);
}

const onMouseOverNode = function(nodeId) {
     window.alert('Mouse over node', nodeId);
};

const onMouseOutNode = function(nodeId) {
     window.alert('Mouse out node', nodeId);
};

<Node
    id='nodeId'
    cx=22
    cy=22
    fill='green'
    fontSize=10
    fontColor='black'
    fontWeight='normal'
    dx=90
    label='label text'
    opacity=1
    renderLabel=true
    size=200
    stroke='none'
    strokeWidth=1.5
    svg='assets/my-svg.svg'
    type='square'
    viewGenerator=(node) => <CustomComponent node={node} />
    className='node'
    onClickNode={onClickNode}
    onRightClickNode={onRightClickNode}
    onMouseOverNode={onMouseOverNode}
    onMouseOutNode={onMouseOutNode} />
```

### handleOnClickNode

Handle click on the node.

Returns **[undefined][117]**

### handleOnRightClickNode

Handle right click on the node.

**Parameters**

-   `event` **[Object][99]** native event.

Returns **[undefined][117]**

### handleOnMouseOverNode

Handle mouse over node event.

Returns **[undefined][117]**

### handleOnMouseOutNode

Handle mouse out node event.

Returns **[undefined][117]**

## Link

**Extends React.Component**

Link component is responsible for encapsulating link render.

**Examples**

```javascript
const onClickLink = function(source, target) {
     window.alert(`Clicked link between ${source} and ${target}`);
};

const onRightClickLink = function(source, target) {
     window.alert(`Right clicked link between ${source} and ${target}`);
};

const onMouseOverLink = function(source, target) {
     window.alert(`Mouse over in link between ${source} and ${target}`);
};

const onMouseOutLink = function(source, target) {
     window.alert(`Mouse out link between ${source} and ${target}`);
};

<Link
    d="M1..."
    source="idSourceNode"
    target="idTargetNode"
    markerId="marker-small"
    strokeWidth=1.5
    stroke="green"
    className="link"
    opacity=1
    mouseCursor="pointer"
    onClickLink={onClickLink}
    onRightClickLink={onRightClickLink}
    onMouseOverLink={onMouseOverLink}
    onMouseOutLink={onMouseOutLink} />
```

### handleOnClickLink

Handle link click event.

Returns **[undefined][117]**

### handleOnRightClickLink

Handle link right click event.

**Parameters**

-   `event` **[Object][99]** native event.

Returns **[undefined][117]**

### handleOnMouseOverLink

Handle mouse over link event.

Returns **[undefined][117]**

### handleOnMouseOutLink

Handle mouse out link event.

Returns **[undefined][117]**

## utils

Offers a series of generic methods for object manipulation, and other operations
that are common across rd3g such as error logging.

### \_isPropertyNestedObject

Checks whether a certain object property is from object type and is a non empty object.

**Parameters**

-   `o` **[Object][99]** the object.
-   `k` **[string][98]** the object property.

Returns **[boolean][97]** returns true if o[k] is an non empty object.

### isDeepEqual

Generic deep comparison between javascript simple or complex objects.

**Parameters**

-   `o1` **[Object][99]** one of the objects to be compared.
-   `o2` **[Object][99]** second object to compare with first.
-   `_depth` **[number][96]** this parameter serves only for internal usage. (optional, default `0`)

Returns **[boolean][97]** returns true if o1 and o2 have exactly the same content, or are exactly the same object reference.

### isEmptyObject

Checks whether or not a certain object is empty.
NOTE: If the passed parameter is not an object the method return false.

**Parameters**

-   `o` **[Object][99]** object whom emptiness we want to check.

Returns **[boolean][97]** true if the given object is n ft and object and is empty.

### deepClone

Function to deep clone plain javascript objects.

**Parameters**

-   `o` **[Object][99]** the object to clone.
-   `_clone` **[Object][99]** carries the cloned output throughout the
    recursive calls. Parameter serves only for internal usage. (optional, default `{}`)
-   `_depth` **[number][96]** this parameter serves only for internal usage. (optional, default `0`)

Returns **[Object][99]** the cloned object.

### merge

This function merges two objects o1 and o2, where o2 properties override existent o1 properties, and
if o2 doesn't posses some o1 property the fallback will be the o1 property.

**Parameters**

-   `o1` **[Object][99]** object. (optional, default `{}`)
-   `o2` **[Object][99]** object that will override o1 properties. (optional, default `{}`)
-   `_depth` **int** the depth at which we are merging the object. (optional, default `0`)

Returns **[Object][99]** object that is the result of merging o1 and o2, being o2 properties priority overriding
existent o1 properties.

### pick

Create new object from the inputted one only with the props passed
in the props list.

**Parameters**

-   `o` **[Object][99]** the object to pick props from.
-   `props` **[Array][100]&lt;[string][98]>** list of props that we want to pick from o. (optional, default `[]`)

Returns **[Object][99]** the object resultant from the picking operation.

### antiPick

Picks all props except the ones passed in the props array.

**Parameters**

-   `o` **[Object][99]** the object to pick props from.
-   `props` **[Array][100]&lt;[string][98]>** list of props that we DON'T want to pick from o. (optional, default `[]`)

Returns **[Object][99]** the object resultant from the anti picking operation.

### throwErr

Helper function for customized error logging.

**Parameters**

-   `component` **[string][98]** the name of the component where the error is to be thrown.
-   `msg` **[string][98]** the message contain a more detailed explanation about the error.

Returns **[Error][135]** the thrown error.

[1]: #graphcollapse-helper
[2]: #_isleafdirected
[3]: #_isleafnotdirected
[4]: #_isleaf
[5]: #computenodedegree
[6]: #gettargetleafconnections
[7]: #isnodevisible
[8]: #togglelinksconnections
[9]: #togglelinksmatrixconnections
[10]: #graphbuilder
[11]: #_getnodeopacity
[12]: #buildlinkprops
[13]: #buildnodeprops
[14]: #graphconfig
[15]: #graphhelper
[16]: #link
[17]: #node
[18]: #_createforcesimulation
[19]: #_initializelinks
[20]: #_initializenodes
[21]: #_mergedatalinkwithd3link
[22]: #_tagorphannodes
[23]: #_validategraphdata
[24]: #_pickid
[25]: #_picksourceandtarget
[26]: #checkforgraphelementschanges
[27]: #checkforgraphconfigchanges
[28]: #getcenterandzoomtransformation
[29]: #initializegraphstate
[30]: #updatenodehighlightedvalue
[31]: #linkconst
[32]: #line_types
[33]: #linkhelper
[34]: #straightlineradius
[35]: #smoothcurveradius
[36]: #fullcurveradius
[37]: #getradiusstrategy
[38]: #buildlinkpathdefinition
[39]: #markerhelper
[40]: #_markerkeybuilder
[41]: #_getmarkersize
[42]: #_computemarkerid
[43]: #_memoizedcomputemarkerid
[44]: #getmarkerid
[45]: #nodehelper
[46]: #_converttypetod3symbol
[47]: #buildsvgsymbol
[48]: #graph
[49]: #_generatefocusanimationprops
[50]: #_graphlinkforceconfig
[51]: #_graphnodedragconfig
[52]: #_graphbindd3toreactcomponent
[53]: #_ondragend
[54]: #_ondragmove
[55]: #_ondragstart
[56]: #_setnodehighlightedvalue
[57]: #_tick
[58]: #_zoomconfig
[59]: #_zoomed
[60]: #onclickgraph
[61]: #onclicknode
[62]: #onmouseovernode
[63]: #onmouseoutnode
[64]: #onmouseoverlink
[65]: #onmouseoutlink
[66]: #pausesimulation
[67]: #resetnodespositions
[68]: #restartsimulation
[69]: #unsafe_componentwillreceiveprops
[70]: #graphrenderer
[71]: #_renderlinks
[72]: #_rendernodes
[73]: #_renderdefs
[74]: #_memoizedrenderdefs
[75]: #rendergraph
[76]: #marker
[77]: #node-1
[78]: #handleonclicknode
[79]: #handleonrightclicknode
[80]: #handleonmouseovernode
[81]: #handleonmouseoutnode
[82]: #link-1
[83]: #handleonclicklink
[84]: #handleonrightclicklink
[85]: #handleonmouseoverlink
[86]: #handleonmouseoutlink
[87]: #utils
[88]: #_ispropertynestedobject
[89]: #isdeepequal
[90]: #isemptyobject
[91]: #deepclone
[92]: #merge
[93]: #pick
[94]: #antipick
[95]: #throwerr
[96]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number
[97]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean
[98]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String
[99]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object
[100]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array
[101]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Statements/function
[102]: #config-node
[103]: https://github.com/danielcaldas/react-d3-graph/issues/129
[104]: https://bl.ocks.org/mbostock/2a39a768b1d4bc00a09650edef75ad39
[105]: https://github.com/d3/d3-force#simulation_alphaTarget
[106]: https://github.com/d3/d3-force#forces
[107]: https://github.com/d3/d3-force#link_strength
[108]: https://developer.mozilla.org/en-US/docs/Web/CSS/font-size?v=control
[109]: https://developer.mozilla.org/en/docs/Web/CSS/font-weight?v=control
[110]: https://developer.mozilla.org/en/docs/Web/CSS/cursor?v=control
[111]: https://github.com/d3/d3-shape#symbols
[112]: https://github.com/d3/d3-force#forceSimulation
[113]: https://github.com/d3/d3-force#simulation_force
[114]: #link
[115]: #node
[116]: #initializeGraphState
[117]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/undefined
[118]: #config
[119]: http://bl.ocks.org/mbostock/1153292
[120]: https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/d
[121]: https://github.com/d3/d3-shape/blob/master/README.md#symbol
[122]: #node-symbol-type
[123]: https://danielcaldas.github.io/react-d3-graph/sandbox/index.html
[124]: https://github.com/danielcaldas/react-d3-graph/blob/master/sandbox/Sandbox.jsx
[125]: d3-force
[126]: d3-drag
[127]: https://github.com/d3/d3-drag/blob/master/README.md#drag_subject
[128]: setState()
[129]: https://github.com/d3/d3-zoom#zoom
[130]: https://github.com/d3/d3-force#simulation_stop
[131]: https://github.com/d3/d3-force#simulation_restart
[132]: https://reactjs.org/blog/2018/06/07/you-probably-dont-need-derived-state.html
[133]: #Link
[134]: https://developer.mozilla.org/en-US/docs/Web/SVG/Element/defs
[135]: https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Error
